% cv. 6 ; na 29.3.2017 (St) ; Jan Hric
% v. 1.3

% Obsah: cv6

% v nvaznosti na minule: 
% - opertory a vrokov formule
%   - pomoc minulho src: eval 
%   - CV: propagace non/1 dolu
% - tok dat: asynchronn odebrn ze seznamu  
% 	naCasti/3
% - heapsort
%   - rozbor
%   - vroba tvaru haldy, 2x
%   - CV: heap2srt/2 a slucHaldy/3
%   DCv: zhalduj/2
% - vloen operace
%   - idiom: generuj a testuj



%%%%%%%%%% z minula: explicitn vsledky:
%
% compare/3: na pednce
% ?- compare( < , 3, 5). % 1.arg
%
% - idiom: vsledky jako data
% podobn pouit: v Prologu pouvan "uspje/neuspje" jsme v eval/3 
%   nahradili explicitnm true/false (a eval/3 vdy uspje)
% podobn pouit: vsledky msto backtrackingu vracme jako seznam een


%%%%%%%%
:- op(210, xfy, [and]).  % def. opertoru and/2
:- op(220, xfy, or). 
:- op(200, fy, non). 
% - non/1 umon display(non non a)).

%%%%%%%%%%%%%%%%%%%%%%%
% CV: propagace non/1 dolu na non, and, or a p/1 true/0, false/0
% dv rovn rekurze ...
propagNon(_VF,__VF) :- true.
propagNon(VF1 and VF2, VF1 and VF2) :- true.
propagNon(VF1 or VF2, VF1 or VF2) :- true.
propagNon(non VF, non VF) :- true.
propagNon(non non _VF, non non _V) :- true.
propagNon(non (_VF1 and _VF2), _V) :- true. % 
propagNon(non (_VF1 or  _VF2), _V) :- true. % 
% ... rozbor ppad u non/1

elementarniVF(VF):- 
  VF = p(_) ; 
  VF = true ;
  VF = false .

tg1(V) :- propagNon( non(p(a) and non(p(b) or non(true))), V).

%%%%%%%%%%%%%%%%%%
% rozdl na sti: duln k rozdlovm seznamm
%
% naCasti(+[Delky],+[Prvky],-[[Casti]]) :- ze seznamu Prvky ubere sti poadovan Delky.
%   Chceme: Delky se mus dt odebrat, Prvk mus bt dost.
% pklad na tok dat

naCasti([],_,[]).
% naCasti([_|_],[],[]).  % jin okrajov podmnka
naCasti([D|Ds],Xs,[V|Vs]):-
  uberCast1(D,Xs,V,Xs1),
  !, 	% mame reseni
  naCasti(Ds,Xs1,Vs).
% varianta: v dalm argumentu zbyl prvky 

uberCast(D,Xs,V,Xs1) :-
  length(V,D),  % vyrob seznam volnch promnnch 
  append(V,Xs1,Xs).	% napln ho
% length/2 nejdv je ponkud efektivnj ne (opakovan) kontrolovn odebran dlky

% varianta, syntaktick 
uberCast1(0,Xs,[],Xs).	% to sam, explicitn rekurze
uberCast1(D,[X|Xs],[X|V],Xs1) :-
  D>0, D1 is D-1,
  uberCast1(D1,Xs,V,Xs1).

% voln:
% ?- naCasti([1,2,3],[a,b,c,d,e,f,g,h,i],V]).
%  V=[[a],[b,c],[d,e,f]]
% ! tok dat:
% naCasti([1,2,3],Xs,[V1,V2,V3]) :-
%   uberCast(1,Xs,V1,Xs1), uberCast(2,Xs1,V2,Xs2), uberCast(3,Xs2,V3,_Xs3).
% vstupn seznam Xs se postupn zkracuje na Xs1, Xs2, ...


%%%%%%%%%%%%%%%%%%%%%%%%%%
% heapSort: rozbor:
% heapsort (s binrn haldou)
% - postav tvar heapu, zhalduj, vybrej
%   - vyuv rozdel/3
%   - stavba: prvek pro vrchol utrhnu hned
% - stavba: doleva doprava
% - hned stavt haldu (rozdl a panuj)
%   - minimum do koene a zbytek rozdlit
%   - stavba v O(n log n)
%   - klasika je postavit 2 subhaldy a potom 1 prvek vloit, O(n) asi
% - kapitnsk krok: hloubka je pod logaritmick
%   - (ani) pi vybrn nemusm udrovat vyvenou haldu
%     - posledn halda je nepln
%   - vybrn v O(n log n)


%%%%%%%%%%%%%%%%%
% heapsort
% CV: sluovn hald

heapsort(Ls,Vs):-
  mkHaldaKK(0,Ls,[],nil,Neheap), % vyrob tvar haldy
  zhalduj(Neheap, Heap), % zajist splnn haldovch podmnek
  halda2srt(Heap,Vs).

%%%%%%%%%%
% CV , pevod haldy na uspodan seznam
halda2srt(nil,[]).
halda2srt(t(_L,_X,_P), Vs):- 
  true,
  halda2srt(_,Vs).

%%%%%%%%%  CV
% slucHaldy(L,P,V) :- slouci haldy L a P do V
slucHaldy(nil, P,   P).
slucHaldy(L  , nil, L).  
  % :- L \= nil. % prava pro nepekrvn podmnek
slucHaldy(t(_LL,LX,_LP), t(_PL,PX,_PP), V) :-
  LX =< PX ->	V = t(_,_,_),
		slucHaldy(L, P, VV)
           ;	V = t(_,_,_),
		slucHaldy(L, P, VV) . 
% - koncov podmnky se pekrvaj ( pro slucHaldy(nil,nil,nil) ), ale jsou deklarativn sprvn

% varianta: mme L a P vcelku, nejvy rove struktury se nebuduje znova
% slucHaldy(L,P,V) :- 
%    L = t(LL,LX,LP), P = t(PL,PX,PP), 
%    ( LX <= PX  -> V = t(VL,LX,P), % P vcelku
%		    slucHaldy(_,_,VL)
%    ; ... )	% symetricky 
% - zvorky okolo if->then;else potebujeme

%%%%%%%%%%%%%%%%%%
% - kapitnsk krok: postupn zvtovn hranice, exponenciln (tj. nsobn v kadm kroku)
% - pro heapsort neprodukuje vyvenou haldu, ale log. hloubka sta
% - te data ve vstupnm poad 

%%%%%%%%%%%%%%%%%%
% mkHaldaKK(+D,+Ls,-Ls0,+H1,-Heap) :- z Ls vyrb haldu Heap hloubky D kapitnskm krokem, 
%	H1 je prbn vyroben, Ls0 jsou zbyl prvky
mkHaldaKK(_D,[],[],Heap,Heap).
mkHaldaKK(D ,[X|Ls1],Ls0,Heap1,Heap0) :-
  mkHaldaD(D,Ls1,Ls2,Heap2),
  D1 is D+1,
  mkHaldaKK(D1,Ls2,Ls0,t(Heap1,X,Heap2),Heap0).

% mkHaldaD(+D,+Ls1,-Ls0,-Heap) :- vyrob haldu hloubky D, zbyl prvky v Ls0
mkHaldaD(0,Ls,Ls,nil) :- !. % ez kvli druh koncov podmnce
mkHaldaD(_D,[],[],nil).     % doly prvky
mkHaldaD(D,[X|Ls1],Ls0,t(H1,X,H2)):-
  D>0, D1 is D-1,
  mkHaldaD(D1,Ls1,Ls2,H1),
  mkHaldaD(D1,Ls2,Ls0,H2).

tg2(Xs-V):- mkHaldaD(3,[e,d,c,b,a],Xs,V).
tg3(V):- mkHaldaKK(0,[e,d,c,b,a],[],nil,V).

/* mkHaldaD		mkHaldaKK
    e			    b
   / \			   / \
  d   a			  d   a
 / \			 / \
c   b			e   c

*/



%%%%%%%%%%%%%%
% vloen operace:
% vlozeni(Xs, Strom, V) :- doplnit mezi cifry aritmetick operace +, -, *, / 
%	a spojen cifer do sla, aby vyel poadovan vsledek.
vlozeni(Xs,Xs,V) :- sezNaCislo(Xs,0,V).
  % vlozeni(Xs,cislo(Xs),V) :- ...  % pokud chceme odliovat sla tagem
vlozeni(Xs,Strom,V):-
  Strom = op(A1,Op,A2), % var s ops1/5: zakomentovat
  append(Xs1,Xs2,Xs), Xs1\=[], Xs2\=[],
  vlozeni(Xs1,A1,V1),
  vlozeni(Xs2,A2,V2),
  ops(Op,V1,V2,V).	% povolen operace, vetn smantiky (4.arg) 
  % ops1(_Op,V1-A1,V2-A2,V,Strom). % pidn vstupn stromov syntaxe

% vpoet hodnoty z cifer (destkov) pozin soustavy
sezNaCislo([],V,V).
sezNaCislo([X|Xs],V1,V0) :-
  V2 is V1*10+X,
  sezNaCislo(Xs,V2,V0).

ops(+,V1,V2,V) :- V is V1+V2.
ops(*,V1,V2,V) :- V is V1*V2.
ops(-,V1,V2,V) :- V is V1-V2, V >= 0.
ops(/,V1,V2,V) :- V2>0, V is V1 // V2, V1 mod V2 =:= 0. % vetn testu

ops1(+,V1-A1,V2-A2,V,A1+A2) :- V is V1+V2.
ops1(*,V1-A1,V2-A2,V,A1*A2) :- V is V1*V2.
ops1(-,V1-A1,V2-A2,V,A1-A2) :- V is V1-V2, V >= 0.
ops1(/,V1-A1,V2-A2,V,A1/A2) :- V2>0, V is V1 // V2, V1 mod V2 =:= 0. % vetn testu

% na rozmylen: pevst na seznam vsledk


%%%%%
% DCv: zhalduj(+Neheap, -Heap) :- vytvoen Heap zachov tvar Neheap, 
%	ale zajist haldovou podmnku (pedek < potomek)

/* %%%%%%%%%%
  dal:
  - na asynchronn odbrn vstupu:
    - minimov strom, z ADS1
 	Vstup a_1 a a_n. Stavme binrn strom. V koeni je minimum posloupnosti, 
 	nech je to a_j. Pak lev podstrom je minimov strom z a_1 a a_(j-1) a prav 
	podstrom minimov strom z a_(j+1) a a_n. Konstrukce v O(n), klasicky. Uren jednoznan.
*/ 

%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkoueli (nebo mli zvldnout):
% - (rozdlove seznamy a) asynchronn odebrn vstupu, predvn zbytku stavem
% - zexplicitnn dat
% - zpracovn termovch (tj. stromovch) struktur (opt)
% - generuj a testuj



%%%%%%%%%%%%%


%%%%%%%%%%%%%%%
% stromy, binrn: funktory: t/3, nil/0
% proc. prohledani/2, vyda casy otevreni a uzavreni vrchol, v seznamu

/*  * /
/ *
*/

%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli:
% -
% -
% -
% -
% -
% -
% -
% -

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% runtime
check(Tested,=,Pattern) :- 
  Tested = Pattern -> write(passed),nl
                   ;  write(error),nl, 
		      write(value__(Tested)),nl, 
		      write(expected(Pattern)),nl.

%----------------

% k.
