#lang racket
;#lang s-exp	; NE

; testy pre racket

; comment 
; (enter! "tracket.rkt") 
;    spoustet ve stejnem adresari ...
; -- (enter! "c:/data/pgm/tracket.rkt") -- bez cesty NE
; -- ,enter "c:/data/pgm/tracket.rkt"  NE

; (exit) ; OK

(define delka 7)

(define (kvadrat x) (* x x))

(kvadrat delka)

(null? '())  ; '() musi mit apostrof, a nil nefunguje

(number? 42)

(symbol? 'a)

#f  ; bool. konstanta

(define (append xs ys) ; vrac seznam, kter vznikne spojenm xs a ys 
  ( if (null? xs) ; test na przdn seznam xs 
       ys ; then  vra ys 
       (cons (car xs) (append (cdr xs) ys)) ; else  rekurze; vracme sloen vraz 
) ) ;

(append '(a b) (list 'c 'd))

; abs1, abs2
(define (abs x) 
  (cond ((> x 0) x) 
        ((< x 0) (- x)) 
        ((= x 0) 0) ; typicky zchytn podmnka: else, #t 
) )

(abs -5)

(define (abs1 x ) (if (> x 0) x (- x)) )

"abs1"
(and (> (abs1 -5) 0) (> (abs1 5) 0))

(define (>= x y ) (or (> x y) (= x y)) )

; faktorial1, faktorial2
(define (faktorial1 n) 
  ( if (= n 1) 
       1 
       (* n (faktorial1 (- n 1))) 
) )

(define (faktorial2 n) ; nen rekurzivn, pouze interface 
  (define (f_iter soucin counter n) ; invariant: soucin = (counter-1)! 
    (if (> counter n) soucin ; konec rekurze - vydn akumultoru 
    (f_iter (* soucin counter) (+ counter 1) n) ; rekurze, TRO 
  ) ) ; konec loklnho define 
  (f_iter 1 1 n) ; tlo, pouze voln vlastn rekurze s akum. 
)

(faktorial1 4)
(faktorial2 5)

; gcd1
(define (gcd1 a b)
  (if (= b 0)
      a
      (gcd1 b (remainder a b)) 
) )

; ... ukazka, z prednky
(define (f x y)
  (let ( (prum     (/ (+ x y) 2)              )
         (kvadrat (lambda (x) (* x x)) ) )   ; def. lok. funkce
       (+ (kvadrat (- x prum)) (kvadrat (- y prum)) )
)   )  

; qsort, chybi split
(define (qsort xs) 
  (if (null? xs) xs 
    (let ((pair (split (car xs) (cdr xs)) )) ; vrac dva seznamy 
      (append (qsort (car pair)) ; pouit prvn sti 
              (cons (car xs) (qsort (cdr pair))) )))) ; a druh .

(define (split pivot xs) (cons '() '() )) ; 

; cons car cdr
(define a (cons 1 2))

"a-cons:"
a

(car a)

(cdr a)

(cons '1 '(2 3))

(list 1 2 3)

(list? '(2 3))
(list? 'a)

; nth, length
(define (nth n xs) 	 ; vybere n-t prvek z xs, bez oeten chyby
	(if (= n 1)		 ; podm. ukonen rekurze
		(car xs)		 ; koncov hodnota
		(nth (- n 1) (cdr xs))	 ; rekurzivn voln, na tlo xs
)  )

(define (length xs)	; spot dlku seznamu
	(if (null? xs)
		0
		(+ 1 (length (cdr xs)))  ; nen tail-rekurzivn, length je uvnit +
)	)

(nth 2 '(11 12 13))
(length '(11 12 13))

; reverse1
(define (reverse1 xs)
  (if (null? xs)
      '()
      (append (reverse1 (cdr xs)) (list (car xs))) 	; v O(n^2)
))

(reverse1 '(21 22 23))

; lambda:
((lambda (x) (+ x 1)) 6)	; ! dvoje zavorky

(map (lambda (x) (* x 0.9)) '(20 30 40))

(define (mkConstFnc c) (lambda (x) c)) 

((mkConstFnc 7) 2)

(define (mkAddC c) (lambda (x) (+ x c)))

((mkAddC 7) 5)

(define (twice f) (lambda (x) (f (f x)) ))	; DC pro n aplikac

((twice (twice kvadrat)) 3)  ; 3^16 = 3^((2^2)^2)		

(exp (* 16 (log 3)))

(define (filter1 p xs)    ;ve vstupnm s. prvky x   xs, pro kter plat p(x)
	(cond ((null? xs)    xs                                               )   ; konec sezn.
		    ((p (car xs)) (cons (car xs) (filter1 p (cdr xs))) )   ; opakovn?
		    (else            (filter1 p (cdr xs))                         ) ));zdvojen nevad

(define (qs1 cmp xs)	; 1. (cmp a b) vrac a < b
	(if (null? xs)		; 2. cmp je rozumn abstrakce: detaily schovan
		xs  			; 3: td vdy vzestupn a vdy cel objekty
		(append (qs1 cmp (filter1 (lambda (x) (cmp x (car xs))) (cdr xs)))
		   (cons (car xs) 	 	; pidn hlavy xs doprosted vsledku
		      (qs1 cmp (filter1 (lambda (x) (not(cmp x (car xs)))) (cdr xs))) 
)	)	)  )	 ;; opakujc se (car xs) lze odstranit pomoc let

(qs1 >= '(1 3 5 7 9 4 8 6 2) )

(define (qsort2 cmp xs)	; cmp je funkcionln param/2
  (if (null? xs) xs
     (let ((pair (split2 cmp (car xs) (cdr xs)) )) ; vrac dva seznamy 
		(append (qsort2 cmp (car pair))
                       (cons (car xs) (qsort2 cmp (cdr pair))) ))))
(define (split2 cmp x ys)	; vrac dvojice, tj. cons
	(if (null? ys)
		(cons '() '())	; dvojice przdnch
		(let ((pair (split2 cmp x (cdr ys))))   ; pamatuje si dvojici z rek.
		    (if (cmp (car ys) x)   ; pid hlavu ys ke sprvn sloce
			(cons (cons (car ys) (car pair))  (cdr pair)                )
			(cons (car pair)                  (cons (car ys) (cdr pair)))
)	)	) )

(qsort2 >= '(1 3 5 7 9 4 8 6 2 -1) )


; quote
'(+ 2 3)
(quote (+ 2 3))

(list (quote a) delka)

"(car (quote (a b c) ))"
(car (quote (a b c) ))
(list 'car (list 'quote '(a b c)))

; komplexni cisla
(define (mkPolar z fi)		; konstruktory datov struktury
	(cons 'polar (cons z fi)) )	; polrn tvar, tag 'polar
(define (mkRect re im) 	; analogicky konstruktor pro pravohl tvar, tag 'rect
	(cons 'rect (cons re im)) ) 	; implementace: trojice, ze dvou dvojic
    ; funkce maj/mus pijmat ob reprezentace

(define (isRectTag c) (eq? 'rect (car c)))	; test tagu
(define (re c) (car (cdr c))) 	; selektory
(define (im c) (cdr (cdr c))) 	; !nen to tet prvek seznamu:	
(define (toRect c) 	 ; pevod na pravohl tvar
  (if (isRectTag c) 	 ; test tagu
    	c		 ; 'rect tvar c bez zmny
	    (mkRect (*  (cadr c)(cos (cddr c))) ; selektory: velikost, hel
	            (*  (cadr c)(sin (cddr c)))	 ; vpoet imag. sloky
) ) )		 ; vstup je vdy pravohly tvar  v else konstr. mkRect
  
(define (+compl x y) ; souet komplexnch sel, ve dvoj reprezentaci
  (if (and (isRectTag x) (isRectTag y))
	(mkRect (+ (re x)  (re y)) 		 ; srovnej s (A)
	        (+ (im x) (im y)) )
	(+compl (toRect x) (toRect y)) ))		

; Bez pomocnch definic, sti kdu se opakuj  nchyln k chybm?:
(define (+compl2 x y)	; stn komplexnch sel
	(if (and (eq? 'rect (car x)) (eq? 'rect (car y)))
		(cons 'rect (cons (+ (cadr x) (cadr y))		; selektor re, (A)
				              (+ (cddr x) (cddr y)) ))	; im
		(if (eq? 'polar (car x)) 	; else: uri patn arg., peve a volej rekurzivn
			(+compl (toRect x) y)		; bu pevod x
			(+compl x (toRect y)) 		; anebo pevod y, neefektivn ?
)	)	)  

(+compl (mkRect 1 1 ) (mkPolar 1 (/ pi 4)))  ; pi/4 = 45
(+compl2 (mkRect 1 1 ) (mkPolar 1 (/ pi 4)))  ; pi/4 = 45


; BVS
(define (mkT l x r) 		; konstruktor (neprzdneho) vrcholu
	(cons x (cons l r)) )	; trojice ze dvou dvojic, (implementace: dv buky)
(define (getl t) (cadr t))	; selektory: get levy
(define (getr t) (cddr t))	; get pravy
(define (getval t) (car t))	; get hodnoty
(define (nullT? t) (null? t))	; test druhu struktury
; varianta: (mn efektivn na pam  ti buky)
(define (mk2T l x r) (list x l r))	

; Vkldn do binrnho stromu 
(define (insert x t) 
  (if (nullT? t) (mkT '() x '())	; ukonen rekurze, przdn strom
     (if (< x (getval t)) (mkT (insert x (getl t)) (getval t) (getr t))
		 	                    (mkT (getl t) (getval t) (insert x (getr t)))
)))

(insert 4 
  (insert 2 
    (insert 0 (mkT '() 1 (mkT '() 3 '() )) )
) )

; map1
(define  (map1 f xs)	 ; map - transformace xs fc f po prvcch 1:1
	(if (null? xs)
		  '()
		  (cons (f (car xs)) (map f (cdr xs))) ))

(define (matrix_map f m)
	(map (lambda (vect) (map f vect)) m) ) ; dv rovn map

(matrix_map (lambda (x) (* 10 x)) '((1 2 3) (4 5 6)) )

(define (transp m)	 ; transpozice matice, pouit map
  (if (null? (car m)) 	; je prvn dek przdn?
      '()	 			; vra przdnou matici
	    (cons (map car m) (transp (map cdr m))) )) ; spoj 1.. a transp. zbytku

"testy_transp:"
(transp '((1 2 3) (4 5 6)))

(equal? '((1 2 3) (4 5 6)) 
        (transp (transp '((1 2 3) (4 5 6)) )) 
)
